#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/select.h>
#include <unistd.h>
#include <iostream>
#include <cstring>

using namespace std;

int main ()
{
    int sock, client;
    sockaddr_in addr, client_addr;
    size_t size;

    sock = socket (PF_INET, SOCK_STREAM, 0);

    memset (&addr, 0, sizeof (addr));
    addr.sin_family = PF_INET;
    addr.sin_port = htons (9000);
    addr.sin_addr.s_addr = htonl (INADDR_ANY);
    if (bind (sock, (struct sockaddr *) &addr, sizeof(struct sockaddr)))
    {
        perror ("Problem z funkcja bind: ");
        return 1;
    }

    listen (sock, 10);
    size = sizeof (client_addr);
    cout << "Czekam na polaczenie sieciowe na porcie 9000 ..." << endl;
    client = accept (sock, (struct sockaddr *) &client_addr, &size);

    fd_set desk;
    FD_ZERO (&desk);
    FD_SET (0, &desk);
    FD_SET (client, &desk);

    struct timeval t;
    t.tv_sec = 5;
    t.tv_usec = 0;

    cout << "start" << endl;
    int event = select (FD_SETSIZE, &desk, NULL, NULL, &t);
    cout << "stop" << endl;

    if (event)
    {
        char buf;
        if (FD_ISSET (0, &desk))
        {
            read (0, &buf, 1);
            cout << "Odczytano ze standardowego wejscia znak: " << buf << endl;
        }
        else if (FD_ISSET (client, &desk))
        {
            read (client, &buf, 1);
            cout << "Odczytano z polaczenia sieciowego znak: " << buf << endl;
        }
        else
        {
            cout << "Cos jest nie tak :)" << endl;
        }
    } else {
        cout << "Nie odczytano" << endl;
    }
    return 0;
}
